Attribute VB_Name = "Index_tools"
Public lev01_file, first_level(10), level1_files(10), level1_levels(10) As String
Public level1_type, high, ixd_fam, my_mark, selected_text, fam, fam_sep  As String
Public my_change, default_f, default_p, no_f_l1, new_file As Long
Public my_obj As Object
Public no_l1, cancel_flag As Long
Sub aa_setup_keys()
' This macro sets up key assignments. It takes the choices you make
' about the style of indexes you want and enables them with the
' appropriate key assignments.
' The first choice is the way you get the first level of indexing,
' the two choices are flagged (recommended) or grouped.
' The second choice is the style of family indexing and the choices are
' grouped at family level (recommended) or no grouping just individuals.
Load select_keys
select_keys.Show
Unload select_keys
If cancel_flag = 1 Then Exit Sub
CustomizationContext = NormalTemplate
If ixd_fam = "group" Then
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyF), KeyCategory:=wdKeyCategoryMacro, Command:="index_fam_first_i_colon"
Else
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyF), KeyCategory:=wdKeyCategoryMacro, Command:="index_fam_first_i_comma"
End If
KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyP), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase"
If high = "flag" And ixd_fam = "group" Then
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyG), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_f_colon"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyH), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_f_no_sel_colon"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyQ), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_f"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyW), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_f_no_sel"
End If
If high = "flag" And ixd_fam = "individual" Then
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyG), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_f_comma"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyH), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_f_no_sel_comma"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyQ), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_f"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyW), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_f_no_sel"
End If
If high = "group" And ixd_fam = "individual" Then
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyG), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_g_comma"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyH), KeyCategory:=wdKeyCategoryMacro, Command:="index_family_first_g_no_sel_comma"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyQ), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_g"
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyW), KeyCategory:=wdKeyCategoryMacro, Command:="index_phrase_g_no_sel"
End If
If high = "flag" Then KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyControl, wdKeyShift, wdKeyI), KeyCategory:=wdKeyCategoryMacro, Command:="add_index"
End Sub
Sub split_fam()
fore = ""
next_char = ""
i = 0
While next_char <> " " And i < Len(selected_text)
    i = i + 1
    next_char = Left(Right(selected_text, i), 1)
Wend
fam = Trim(Right(selected_text, i))
If i < Len(selected_text) Then
    fore = Trim(Left(selected_text, Len(selected_text) - i))
    fam = fam & fam_sep & fore
End If
End Sub
Sub mark_it()
Selection.Collapse Direction:=wdCollapseEnd
Selection.Fields.Add Range:=Selection.Range, Type:=wdFieldEmpty, PreserveFormatting:=False
Selection.TypeText Text:=my_mark
End Sub
Sub index_each_wd_as_level()
'assign to {ctrl}{shift}{
' Nick Reddan used with permission
'It indexed the phrase so that each word is a separate level
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
selected_text = Replace(selected_text, "  ", " ")
selected_text = Replace(selected_text, "  ", " ")
selected_text = Replace(selected_text, "  ", " ")
selected_text = Replace(selected_text, " ", ": ")
my_mark = "XE " & Chr(34) & selected_text & Chr(34)
mark_it
End Sub
Sub index_fam_first_i_comma()
'assign to {ctrl}{shift}F
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Smith, John"
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
fam_sep = ", "
split_fam
my_mark = "XE " & Chr(34) & fam & Chr(34)
mark_it
End Sub
Sub index_fam_first_i_colon()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Smith, John"
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
fam_sep = ": "
split_fam
my_mark = "XE " & Chr(34) & fam & Chr(34)
mark_it
End Sub
Sub index_family_first_f_comma()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Term: Smith, John"

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
'lev01_file = "idx_lev_01f.txt"
get_l1_list_file_name

read_level_1
select_level_1

If Len(first_level(0)) > 0 Then first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
fam_sep = ", "
split_fam
fam = fam & Chr(34) & first_level(0)
my_mark = "XE " & Chr(34) & fam
mark_it
write_level_1
End Sub
Sub index_family_first_f_colon()
'assign to {ctrl}{shift}G
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Term: Smith, John"

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
'lev01_file = "idx_lev_01f.txt"
get_l1_list_file_name

read_level_1
select_level_1

If Len(first_level(0)) > 0 Then first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
fam_sep = ": "
split_fam
fam = fam & Chr(34) & first_level(0)
my_mark = "XE " & Chr(34) & fam
mark_it
write_level_1
End Sub
Sub index_family_first_f_no_sel_comma()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Smith, John" with flag \f "term"
'
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
get_l1_list_file_name
read_level_1

first_level(0) = first_level(1)
first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
fam_sep = ", "
split_fam
fam = fam & Chr(34) & first_level(0)
my_mark = "XE " & Chr(34) & fam
mark_it
End Sub
Sub index_family_first_f_no_sel_colon()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Smith, John" with flag \f "term"
'
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
get_l1_list_file_name
read_level_1

first_level(0) = first_level(1)
first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
fam_sep = ": "
split_fam
fam = fam & Chr(34) & first_level(0)
my_mark = "XE " & Chr(34) & fam
mark_it
End Sub
Sub index_family_first_g_comma()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Term: Smith, John"

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
'lev01_file = "idx_lev_01f.txt"
get_l1_list_file_name

read_level_1
select_level_1

If Len(first_level(0)) > 0 Then first_level(0) = first_level(0) & ": "
fam_sep = ", "
split_fam
fam = first_level(0) & fam
my_mark = "XE " & Chr(34) & fam & Chr(34)
mark_it
write_level_1
End Sub
Sub index_family_first_g_no_sel_comma()
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a comma.  Thus "John Smith" is marked as "Smith, John" with flag \f "term"
'
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "f"
get_l1_list_file_name
read_level_1

first_level(0) = first_level(1)
If Len(first_level(0)) > 0 Then first_level(0) = first_level(0) & ": "
fam_sep = ", "
split_fam
fam = first_level(0) & fam
my_mark = "XE " & Chr(34) & fam
mark_it
End Sub
Sub select_level_1()
new_file = 0
my_change = 1
While my_change = 1
    Load Select_lev_1
    Select_lev_1.Show
    Unload Select_lev_1
    If my_change = 1 Then
        Load edit_lev_1
        edit_lev_1.Show
        Unload edit_lev_1
        If new_file = 1 Then
            change_file
        Else
            write_level_1
        End If
        read_level_1
    End If
Wend
End Sub
Sub family_as_first_level()
'assign to {ctrl}{shift}J
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a colon.  Thus "John Smith" is marked as "Smith: John"
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
fore = ""
next_char = ""
i = 0
While next_char <> " " And i < Len(selected_text)
    i = i + 1
    next_char = Left(Right(selected_text, i), 1)
Wend
fam = Trim(Right(selected_text, i))
If i < Len(selected_text) Then
    fore = Trim(Left(selected_text, Len(selected_text) - i))
    fam = fam & ": " & fore
End If
my_mark = "XE " & Chr(34) & fam & Chr(34)
Selection.Collapse Direction:=wdCollapseEnd
Selection.Fields.Add Range:=Selection.Range, Type:=wdFieldEmpty, PreserveFormatting:=False
Selection.TypeText Text:=my_mark
'    ActiveDocument.Indexes.MarkEntry Range:=Selection.Range, Entry:= _
'        fam, EntryAutoText:=fam, CrossReference:="", _
'        CrossReferenceAutoText:="", BookmarkName:="", Bold:=False, Italic:=False
End Sub
Sub index_family_family()
'
'this indexes the selection with ", (family)" added to it
'
    x = Trim(Selection.Text) & ", (family)"
    ActiveDocument.Indexes.MarkEntry Range:=Selection.Range, Entry:=x, _
        EntryAutoText:=x, CrossReference:="", CrossReferenceAutoText:="", _
        BookmarkName:="", Bold:=False, Italic:=Fals
End Sub

Sub index_phrase()
' Nick Reddan used with permission
'This macro index marks the selection as teh selection
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
my_mark = "XE " & Chr(34) & selected_text & Chr(34)
mark_it
End Sub
Sub index_phrase_f()
'assign to {ctrl}{shift}Q
' Nick Reddan used with permission
'This macro index marks the selection as the selection with the level 1 term

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "p"
'lev01_file = "idx_lev_01p.txt"
get_l1_list_file_name
read_level_1
select_level_1

If Len(first_level(0)) > 0 Then first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
selected_text = selected_text & Chr(34) & first_level(0)

my_mark = "XE " & Chr(34) & selected_text
mark_it

End Sub
Sub index_phrase_f_no_sel()
' Nick Reddan used with permission
'This macro index marks the selection as the selection with the level 1 term 1

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "p"
lev01_file = "idx_lev_01p.txt"
get_l1_list_file_name

read_level_1

first_level(0) = first_level(1)
first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
selected_text = selected_text & Chr(34) & first_level(0)
my_mark = "XE " & Chr(34) & selected_text
mark_it
End Sub
Sub index_phrase_g()
'assign to {ctrl}{shift}Q
' Nick Reddan used with permission
'This macro index marks the selection as the selection with the level 1 term

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "p"
'lev01_file = "idx_lev_01p.txt"
get_l1_list_file_name
read_level_1
select_level_1

If Len(first_level(0)) > 0 Then first_level(0) = first_level(0) & ": "
selected_text = first_level(0) & selected_text

my_mark = "XE " & Chr(34) & selected_text & Chr(34)
mark_it

End Sub
Sub index_phrase_g_no_sel()
' Nick Reddan used with permission
'This macro index marks the selection as the selection with the level 1 term 1

selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
level1_type = "p"
lev01_file = "idx_lev_01p.txt"
get_l1_list_file_name

read_level_1

first_level(0) = first_level(1)
If Len(first_level(0)) > 0 Then first_level(0) = first_level(0) & ": "
selected_text = first_level(0) & selected_text
my_mark = "XE " & Chr(34) & selected_text & Chr(34)
mark_it
End Sub
Sub get_l1_list_file_name()
' Nick Reddan used with permission
'This macro loads the lists into the forms

For i = 1 To 10
    level1_files(i) = ""
Next
my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & "lev01_file_list.txt"
Close
If file_there(my_list_file) = 0 Then
    Open my_list_file For Input As #1
    Input #1, default_f
    Input #1, default_p
    i = 3
    While Not EOF(1)
        Input #1, level1_files(i - 2)
        i = i + 1
    Wend
    no_f_l1 = i - 3
    Close
Else
    Open my_list_file For Output As #1
    Print #1, 1
    Print #1, 2
    Print #1, "idx_lev_01f.txt"
    Print #1, "idx_lev_01p.txt"
    Close
    default_f = 1
    default_p = 2
    level1_files(1) = "idx_lev_01f.txt"
    level1_files(2) = "idx_lev_01p.txt"
    no_f_l1 = 2
End If
If level1_type = "f" Then
    lev01_file = level1_files(default_f)
Else
    lev01_file = level1_files(default_p)
End If
End Sub
Sub change_file()
' Nick Reddan used with permission
'This macro manages the lists

my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & "lev01_file_list.txt"
Open my_list_file For Input As #1
Input #1, default_f
Input #1, default_p
i = 3
While Not EOF(1)
    Input #1, level1_files(i - 2)
    i = i + 1
Wend
no_f_l1 = i - 3
Close
For k = 1 To no_f_l1
    my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & level1_files(k)
    level1_levels(k) = ""
    Open my_list_file For Input As #1
    i = 1
    While Not EOF(1)
        Input #1, x
        level1_levels(k) = level1_levels(k) & "|" & x & "|"
        i = i + 1
    Wend
    no_l1 = i - 1
    level1_levels(k) = " has " & Trim(Str(no_l1)) & " entries as follows " & level1_levels(k)
    Close
Next
Load manage_lists
manage_lists.Show
Unload manage_lists
If new_file = 0 Then
    my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & "lev01_file_list.txt"
    Open my_list_file For Output As #1
    Print #1, default_f
    Print #1, default_p
    For nn = 1 To no_f_l1
        Print #1, level1_files(nn)
    Next
    Close
Else
    If new_file = 1 Then
        no_f_l1 = no_f_l1 + 1
        Load new_file_form
        new_file_form.Show
        Unload new_file_form
        my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & "lev01_file_list.txt"
        level1_files(no_f_l1) = lev01_file
        If level1_type = "f" Then
            default_f = no_f_l1
        Else
            default_p = no_f_l1
        End If
        Open my_list_file For Output As #1
        Print #1, default_f
        Print #1, default_p
        For nn = 1 To no_f_l1
            Print #1, level1_files(nn)
        Next
        Close
        read_level_1
        new_file = 0
    Else
        Load new_file_form
        new_file_form.Show
        Unload new_file_form
        read_level_1
        my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & "lev01_file_list.txt"
        If level1_type = "f" Then
            level1_files(default_f) = lev01_file
        Else
            level1_files(default_p) = lev01_file
        End If
        Open my_list_file For Output As #1
        Print #1, default_f
        Print #1, default_p
        For nn = 1 To no_f_l1
            Print #1, level1_files(nn)
        Next
        Close
        new_file = 0
    End If
End If
End Sub
Function f_sep()
x = System.OperatingSystem
If InStr(x, "Mac") > 0 Then
    f_sep = ":"
Else
    f_sep = "/"
End If
End Function

Function file_there(vv)
On Error GoTo not_there
file_there = 0
Open vv For Input As #1
Close #1
Exit Function
not_there:
file_there = 1
End Function
Sub read_level_1()
' Nick Reddan used with permission
'This macro reads the level 1 terms from a text file

'
For i = 0 To 10
    first_level(i) = ""
Next
my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & lev01_file
no_l1 = 0
If file_there(my_list_file) = 0 Then
    Open my_list_file For Input As #1
    i = 1
    While i <= 10 And Not EOF(1)
        Input #1, first_level(i)
        i = i + 1
    Wend
    no_l1 = i - 1
    Close
End If
If no_l1 = 0 Then
    no_l1 = 1
    Load edit_lev_1
    edit_lev_1.Show
    Unload edit_lev_1
    write_level_1
End If
End Sub
Sub write_level_1()
' Nick Reddan used with permission
'This macro saves the level 1 terms in a text file
'
my_list_file = Options.DefaultFilePath(wdDocumentsPath) & f_sep() & lev01_file
Open my_list_file For Output As #1
For i = 1 To no_l1
    Print #1, first_level(i)
Next
Close

End Sub

Sub family_as_first_level_d()
'assign to {ctrl}{shift}G
' Nick Reddan used with permission
'This macro splits the selection at the first space from
'the righthand end and puts that at the beginning of the
'index mark with a colon.  Thus "John Smith" is marked as "Smith: John"
super1 = "Person"
selected_text = Trim(Selection.Text)
If Len(selected_text) = 0 Then Exit Sub
fore = ""
next_char = ""
i = 0
While next_char <> " " And i < Len(selected_text)
    i = i + 1
    next_char = Left(Right(selected_text, i), 1)
Wend
fam = Trim(Right(selected_text, i))
If i < Len(selected_text) Then
    fore = Trim(Left(selected_text, Len(selected_text) - i))
    fam = fam & ": " & fore
End If
my_mark = "XE " & Chr(34) & fam & Chr(34) & " \f " & Chr(34) & super1 & Chr(34)
Selection.Collapse Direction:=wdCollapseEnd
Selection.Fields.Add Range:=Selection.Range, Type:=wdFieldEmpty, PreserveFormatting:=False
Selection.TypeText Text:=my_mark
'    ActiveDocument.Indexes.MarkEntry Range:=Selection.Range, Entry:= _
'        fam, EntryAutoText:=fam, CrossReference:="", _
'        CrossReferenceAutoText:="", BookmarkName:="", Bold:=False, Italic:=False
End Sub

Sub add_index()
Load Which_type
Which_type.Show
Unload Which_type

get_l1_list_file_name

read_level_1
select_level_1

Selection.TypeText Text:=first_level(0)
If Len(first_level(0)) > 0 Then Selection.TypeText Text:=" "
Selection.TypeText Text:="Index"
Selection.Style = ActiveDocument.Styles("Heading 2")
Selection.TypeParagraph
    
If Len(first_level(0)) > 0 Then first_level(0) = " \f " & Chr(34) & first_level(0) & Chr(34)
index_type = "INDEX \c " & Chr(34) & "2" & Chr(34) & first_level(0)
Selection.Fields.Add Range:=Selection.Range, Type:=wdFieldEmpty, Text:= _
        index_type, PreserveFormatting:=True
End Sub
Sub fix_levels()
'
' fix_levels Macro
'
'
    CommandBars("Navigation").Visible = False
    Selection.MoveRight Unit:=wdCharacter, Count:=1
    Selection.MoveLeft Unit:=wdWord, Count:=2, Extend:=wdExtend
    Selection.Delete Unit:=wdCharacter, Count:=1
    Selection.Delete Unit:=wdCharacter, Count:=1
    Selection.MoveRight Unit:=wdCharacter, Count:=1
    Selection.TypeText Text:=" \f ""perso"""
End Sub

Sub fix_lev_tag()
turnoff_quote
On Error GoTo tag_not_found
Selection.HomeKey Unit:=wdStory
my_term = "Person"
my_term = InputBox("Enter the term you want to change", "Change terms", my_term)
my_replace = my_term
my_replace = InputBox("Enter the new term you want", "Change terms", my_replace)
no_replace = 0
While no_replace < 100000
    Selection.Find.ClearFormatting
    With Selection.Find
        .Text = Chr(34) & my_term & ": "
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindAsk
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
    End With
    Selection.Find.Execute
    If Trim(Selection.Text) = "" Then GoTo tag_not_found
    'Selection.Delete Unit:=wdCharacter, Count:=1
    'Selection.Delete Unit:=wdCharacter, Count:=1
    Selection.TypeText Text:=Chr(34)
    Selection.Find.ClearFormatting
    With Selection.Find
        .Text = Chr(34)
        .Replacement.Text = ""
        .Forward = True
        .Wrap = wdFindAsk
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
    End With
    Selection.Find.Execute
    Selection.MoveRight Unit:=wdCharacter, Count:=1
    Selection.TypeText Text:=" \f " & Chr(34) & my_replace & Chr(34)
    no_replace = no_replace + 1
Wend
'Exit Sub
tag_not_found:
If no_replace = 0 Then
    MsgBox ("Term " & Chr(34) & my_term & Chr(34) & " not found")
Else
    MsgBox (Trim(Str(no_replace)) & " occurrences of term " & Chr(34) & my_term & Chr(34) & " replaced")
End If
turnon_quote
End Sub
Sub turnoff_quote()
Options.AutoFormatReplaceQuotes = False
Options.AutoFormatAsYouTypeReplaceQuotes = False
End Sub
Sub turnon_quote()
Options.AutoFormatReplaceQuotes = True
Options.AutoFormatAsYouTypeReplaceQuotes = True
End Sub
Sub total_change()
turnoff_quote
main_dir = "c:\all data\html\tools\"
excel_file = "index.xlsx"
Set my_obj = CreateObject("Excel.application")
my_obj.Visible = True
my_obj.Workbooks.Open (main_dir & excel_file)
last_index = my_obj.Range("last_index").Value
For i = 3567 To last_index
    term1 = my_obj.Cells(i + 1, 2).Value
    term2 = my_obj.Cells(i + 1, 3).Value
    Selection.Find.ClearFormatting
    Selection.Find.Replacement.ClearFormatting
    With Selection.Find
        .Text = term1
        .Replacement.Text = term2
        .Forward = True
        .Wrap = wdFindContinue
        .Format = False
        .MatchCase = False
        .MatchWholeWord = False
        .MatchWildcards = False
        .MatchSoundsLike = False
        .MatchAllWordForms = False
    End With
    Selection.Find.Execute Replace:=wdReplaceAll
    If 0 = i Mod 100 Then
        ActiveDocument.Save
        my_obj.Cells(i + 1, 1).Select
    End If
Next
my_obj.ActiveWorkbook.Close
my_obj_visible = False
Set my_obj = Nothing
turnon_quote
End Sub
